<%--
 * Component: checkintegrity
 *
 * Description:
 *   Checks the integrity of a given study
 *
 * Params:
 *   cStudy      -  Study Instance UID of the study to be checked
 *   cOwnerStaus -  Owner status on the peer. Makes sense only if peer is a child or parent server
 *   cMode       -  full/partial
 *   cCorrection -  Try to fix detected inconsistencies
 *   cVerbose    -  Print debug information
 *
 * TODO: Should be checked and probably re-written
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@
	page import="imagemed.checkintegrity.*, java.util.Properties, imagemed.jsputil.DotcomToolbox,
			imagemed.imsession.*"

%><%@
	page errorPage="../main/exceptionHandler.jsp"

%><HTML><HEAD><TITLE>Check study integrity</TITLE></HEAD>
<BODY><PRE>
<%

	IMSession is = new IMSession(request, response, out);
	is.createIMRequest(false);

	// Study Instance UID
	String parStudy = request.getParameter("cStudy");

	// Owner status if checkintegrity was called from child/parent server
	String parOwnerStatus = request.getParameter("cOwnerStatus");
	int ownerStatus = StudyIntegrity.OWNER_STATUS_UNKNOWN;

	// Check mode: partial/full : partial checks study ownership only ???
	String parMode = request.getParameter("cMode");
	if (parMode == null) {
		parMode = "partial";
	}

	// Try to recover detected inconsistencies
	boolean isRecover = "true".equals(request.getParameter("cCorrection"));

	// Verbose mode
	boolean isVerbose = "true".equals(request.getParameter("cVerbose"));


	String selfID = imagemed.dotcom.DotcomConfig.selfId();

	if (parStudy == null) {
%> Missing parameter: cStudy</PRE></BODY></HTML><%
		return;
	}

	if (isVerbose) {
%>
<A HREF="#checking_<%=selfID%>">Debug logs of checking</A><BR>
<%
		if (isRecover) {
%>
<A HREF="#before_<%=selfID%>">Errors before handling the detected error(s)</A><BR>
<A HREF="#elogs_<%=selfID%>">Debug logs of handling error(s)</A><BR>
<A HREF="#after_<%=selfID%>">Errors after handling the detected error(s)</A><BR>
<%
		}
		else {
%>
<A HREF="#errors_<%=selfID%>">Detected errors</A><BR>
<%
		}	
%>
<A HREF="#summary_<%=selfID%>">Summary of checking</A><BR>
<A NAME="checking_<%=selfID%>"><HR> Checking <%=parStudy %>
<%
	}
	String peerId = null;

	try {
		Properties prpDevice = DotcomToolbox.checkClient(is,null,false);
		peerId = prpDevice.getProperty("ID");
	}       
	catch (Throwable th) {
		// Return as if no record found
		IMEnv.debugLog("checkStudy.jsp EXCEPTION when checking client (caller device is not a dotcom device)");
	}

	if (peerId != null && parOwnerStatus != null) {
		ownerStatus = StudyIntegrity.string2OwnerStatus(parOwnerStatus);
	}

	ErrorList errors = new ErrorList(isVerbose ?  out : null);
	StudyIntegrity integrityChecker = new StudyIntegrity(parStudy, errors, (isVerbose ?  out : null), peerId, ownerStatus , parMode);

	try {
		integrityChecker.check();
%></A>

<%
		if (isRecover) {
		//Check study, display DEBUG, try to correct detected errors
			if (isVerbose) {
%>
<A NAME="before_<%=selfID%>"><HR>
	Errors before handling the detected error(s):
<FONT COLOR='red'>
<%
			errors.print(out);
%>
</FONT></A>
<A NAME="elogs_<%=selfID%>"><HR>
	Debug logs of handling error(s):
<%
//			boolean success = 
				errors.handleErrors(out);
			
%>
</A>
<A NAME="after_<%=selfID%>"><HR>
	Errors after handling the detected error(s):
<FONT COLOR='red'>
<%
			errors.print(out);
%>
</FONT></A>
<%
			}
			else {
				errors.handleErrors(out);
			}
		}
		else if (isVerbose) {
%>
<A NAME="errors_<%=selfID%>"><HR>
	Detected error(s):
<FONT COLOR='red'>
<%
		errors.print(out);
%>
</FONT></A>
<%
%>
<A NAME="summary_<%=selfID%>"><HR>
	Summary of checking:
<%
		}
		int numError = errors.size();
		if (numError == 0) {
%>
<FONT COLOR='green'>Status: OK</FONT></A>	
<%
		}
		else {
%>
<FONT COLOR='red'>
	Status: FAILED
	Number of errors: <%=numError %>

</FONT></A>
<%
		}
	}
	catch (Throwable th) {
%>
Exception caught during integrity check:
<%= th.toString() %>
<%
		th.printStackTrace(new java.io.PrintWriter(out));
	}
%></PRE></BODY></HTML>

