
<%--
 * Component: checkintegrity
 *
 * Description:
 *   Checks the integrity of a given study
 *
 * Params:
 *   cReferenceType   - type of the reference tasks to be searched for (OBJECTFILE, STUDYDIR...)
 *   cReference       - reference tasks to be searched for
 *   cTargetDevice    - remote device tasks to be collected on
 *   cMacro_<name>    - values for macro replacements in task descriptor patterns
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@
	page import="imagemed.checkintegrity.*, java.util.Properties, java.util.Enumeration, 
			java.util.List, imagemed.imsession.*, imagemed.util.*, imagemed.jsputil.*"

%><%@
	page errorPage="../main/exceptionHandler.jsp"

%><%
	response.setContentType("text/plain");

	IMSession is = new IMSession(request, response, out);
	is.createIMRequest(false);

	String peerId = null;

	try {
		Properties prpDevice = DotcomToolbox.checkClient(is,null,false);
		peerId = prpDevice.getProperty("ID");
	}       
	catch (Throwable th) {
		// Return error
		IMEnv.debugLog("collectTasks.jsp EXCEPTION when checking client (caller device is not a dotcom device)");
		out.println("#ERROR: unrecognized peer");
		out.println("#RESULT: FAILED");
		return;
	}

	String parType = request.getParameter("cReferenceType");
	String parReference = request.getParameter("cReference");
	String parTargetDeviceID = request.getParameter("cTargetDevice");

	Properties macros = new Properties();

	Enumeration<?> enu = request.getParameterNames();
	while (enu.hasMoreElements()) {
		String key = (String) enu.nextElement();
			if (!key.startsWith("cMacro_")) {
				continue;
		}
		String value = request.getParameter(key);
		if (value.trim().equals("")) {
			value = null;
		}
		key = key.substring("cMacro_".length());
		macros.setProperty(key, value);
	}

	if (parType == null) {
		out.println("#ERROR: Missing parameter: cReferenceType");
		out.println("#RESULT: FAILED");
		return;
	}
	if (parReference == null) {
		out.println("#ERROR: Missing parameter: cReference");
		out.println("#RESULT: FAILED");
		return;
	}

	try {
		TaskFinder tf = new TaskFinder(null, parTargetDeviceID, peerId);

		List<Task> tasks = tf.findTaskForReference(parType, parReference, macros);

		tf.writeTaskList(tasks, out);
	}
	catch (Throwable th) { 
		out.println("#ERROR: Exception caught during integrity check:");
		out.println(Helper.throwable2String(th));
		return;
	}

	out.println("#RESULT: OK");
%>
