<%--
 * Component: checkintegrity
 *
 * Description:
 *   Returns study ownership information for a study
 *
 * This page is supposed to be called by peer server only, so it produces output in a processable format.
 *
 * Params:
 *   cStudy       -  Study Instance UID of the study to be checked
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@
	page import="imagemed.checkintegrity.*, java.util.Properties, imagemed.jsputil.DotcomToolbox,
			imagemed.imsession.*, imagemed.util.Helper"

%><%@
	page errorPage="../main/exceptionHandler.jsp"

%><%
	response.setContentType("text/plain");

	IMSession is = new IMSession(request, response, out);

	// Check peer first
	String peerId = null;
	try {
		Properties prpDevice = DotcomToolbox.checkClient(is, null, false);
		peerId = prpDevice.getProperty("ID");
	}       
	catch (Throwable th) {
		out.println("#RESULT: FAILED");
		out.println("#REASON: Unrecognized peer");
		return;
	}


	String parStudy = request.getParameter("cStudy");

	if (parStudy == null) {
		out.println("#RESULT: FAILED");
		out.println("#REASON: Missing parameter: cStudy");
		return;
	}


	String selfID = imagemed.dotcom.DotcomConfig.selfId();

	out.println(" peer ID : " + peerId);
	out.println(" self ID : " + selfID);
	
	ErrorList errors = new ErrorList(out);
	// Use constructor created for ownership checking
//	StudyIntegrity integrityChecker = new StudyIntegrity(parStudy, errors, peerId);
	StudyIntegrity integrityChecker = new StudyIntegrity(parStudy, errors, out, peerId, StudyIntegrity.OWNER_STATUS_UNKNOWN, "partial");

	try {
		int ownerStatus = integrityChecker.getOwnershipStatus();
		out.println("#STUDY_OWNER: " + StudyIntegrity.ownerStatus2String(ownerStatus));

		int numErrors = errors.size();
		if (numErrors != 0) {
			out.println("#ERRORS DETECTED:");
			errors.write(out);
			return;
		}
	}
	catch (Throwable th) {
		out.println("#RESULT: FAILED");
		out.println("#REASON: Exception caught");
		out.println(Helper.throwable2String(th));
	}

	if (true) {
		// For avoiding extra newline(s)
		return;
	}
%>
